<?php

namespace Ups_ship\UPSshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactType UPSshipStruct
 * @package Ups_ship
 * @subpackage Structs
 */
class Ups_shipContactType extends AbstractStructBase
{
    /**
     * The ForwardAgent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipForwardAgentType
     */
    public $ForwardAgent;
    /**
     * The UltimateConsignee
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipUltimateConsigneeType
     */
    public $UltimateConsignee;
    /**
     * The IntermediateConsignee
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipIntermediateConsigneeType
     */
    public $IntermediateConsignee;
    /**
     * The Producer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipProducerType
     */
    public $Producer;
    /**
     * The SoldTo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipSoldToType
     */
    public $SoldTo;
    /**
     * Constructor method for ContactType
     * @uses Ups_shipContactType::setForwardAgent()
     * @uses Ups_shipContactType::setUltimateConsignee()
     * @uses Ups_shipContactType::setIntermediateConsignee()
     * @uses Ups_shipContactType::setProducer()
     * @uses Ups_shipContactType::setSoldTo()
     * @param \Ups_ship\UPSshipStruct\Ups_shipForwardAgentType $forwardAgent
     * @param \Ups_ship\UPSshipStruct\Ups_shipUltimateConsigneeType $ultimateConsignee
     * @param \Ups_ship\UPSshipStruct\Ups_shipIntermediateConsigneeType $intermediateConsignee
     * @param \Ups_ship\UPSshipStruct\Ups_shipProducerType $producer
     * @param \Ups_ship\UPSshipStruct\Ups_shipSoldToType $soldTo
     */
    public function __construct(\Ups_ship\UPSshipStruct\Ups_shipForwardAgentType $forwardAgent = null, \Ups_ship\UPSshipStruct\Ups_shipUltimateConsigneeType $ultimateConsignee = null, \Ups_ship\UPSshipStruct\Ups_shipIntermediateConsigneeType $intermediateConsignee = null, \Ups_ship\UPSshipStruct\Ups_shipProducerType $producer = null, \Ups_ship\UPSshipStruct\Ups_shipSoldToType $soldTo = null)
    {
        $this
            ->setForwardAgent($forwardAgent)
            ->setUltimateConsignee($ultimateConsignee)
            ->setIntermediateConsignee($intermediateConsignee)
            ->setProducer($producer)
            ->setSoldTo($soldTo);
    }
    /**
     * Get ForwardAgent value
     * @return \Ups_ship\UPSshipStruct\Ups_shipForwardAgentType|null
     */
    public function getForwardAgent()
    {
        return $this->ForwardAgent;
    }
    /**
     * Set ForwardAgent value
     * @param \Ups_ship\UPSshipStruct\Ups_shipForwardAgentType $forwardAgent
     * @return \Ups_ship\UPSshipStruct\Ups_shipContactType
     */
    public function setForwardAgent(\Ups_ship\UPSshipStruct\Ups_shipForwardAgentType $forwardAgent = null)
    {
        $this->ForwardAgent = $forwardAgent;
        return $this;
    }
    /**
     * Get UltimateConsignee value
     * @return \Ups_ship\UPSshipStruct\Ups_shipUltimateConsigneeType|null
     */
    public function getUltimateConsignee()
    {
        return $this->UltimateConsignee;
    }
    /**
     * Set UltimateConsignee value
     * @param \Ups_ship\UPSshipStruct\Ups_shipUltimateConsigneeType $ultimateConsignee
     * @return \Ups_ship\UPSshipStruct\Ups_shipContactType
     */
    public function setUltimateConsignee(\Ups_ship\UPSshipStruct\Ups_shipUltimateConsigneeType $ultimateConsignee = null)
    {
        $this->UltimateConsignee = $ultimateConsignee;
        return $this;
    }
    /**
     * Get IntermediateConsignee value
     * @return \Ups_ship\UPSshipStruct\Ups_shipIntermediateConsigneeType|null
     */
    public function getIntermediateConsignee()
    {
        return $this->IntermediateConsignee;
    }
    /**
     * Set IntermediateConsignee value
     * @param \Ups_ship\UPSshipStruct\Ups_shipIntermediateConsigneeType $intermediateConsignee
     * @return \Ups_ship\UPSshipStruct\Ups_shipContactType
     */
    public function setIntermediateConsignee(\Ups_ship\UPSshipStruct\Ups_shipIntermediateConsigneeType $intermediateConsignee = null)
    {
        $this->IntermediateConsignee = $intermediateConsignee;
        return $this;
    }
    /**
     * Get Producer value
     * @return \Ups_ship\UPSshipStruct\Ups_shipProducerType|null
     */
    public function getProducer()
    {
        return $this->Producer;
    }
    /**
     * Set Producer value
     * @param \Ups_ship\UPSshipStruct\Ups_shipProducerType $producer
     * @return \Ups_ship\UPSshipStruct\Ups_shipContactType
     */
    public function setProducer(\Ups_ship\UPSshipStruct\Ups_shipProducerType $producer = null)
    {
        $this->Producer = $producer;
        return $this;
    }
    /**
     * Get SoldTo value
     * @return \Ups_ship\UPSshipStruct\Ups_shipSoldToType|null
     */
    public function getSoldTo()
    {
        return $this->SoldTo;
    }
    /**
     * Set SoldTo value
     * @param \Ups_ship\UPSshipStruct\Ups_shipSoldToType $soldTo
     * @return \Ups_ship\UPSshipStruct\Ups_shipContactType
     */
    public function setSoldTo(\Ups_ship\UPSshipStruct\Ups_shipSoldToType $soldTo = null)
    {
        $this->SoldTo = $soldTo;
        return $this;
    }
}
