<?php

namespace Ups_ship\UPSshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EEIInformationType UPSshipStruct
 * @package Ups_ship
 * @subpackage Structs
 */
class Ups_shipEEIInformationType extends AbstractStructBase
{
    /**
     * The ExportInformation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ExportInformation;
    /**
     * The License
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipEEILicenseType
     */
    public $License;
    /**
     * The DDTCInformation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipDDTCInformationType
     */
    public $DDTCInformation;
    /**
     * Constructor method for EEIInformationType
     * @uses Ups_shipEEIInformationType::setExportInformation()
     * @uses Ups_shipEEIInformationType::setLicense()
     * @uses Ups_shipEEIInformationType::setDDTCInformation()
     * @param string $exportInformation
     * @param \Ups_ship\UPSshipStruct\Ups_shipEEILicenseType $license
     * @param \Ups_ship\UPSshipStruct\Ups_shipDDTCInformationType $dDTCInformation
     */
    public function __construct($exportInformation = null, \Ups_ship\UPSshipStruct\Ups_shipEEILicenseType $license = null, \Ups_ship\UPSshipStruct\Ups_shipDDTCInformationType $dDTCInformation = null)
    {
        $this
            ->setExportInformation($exportInformation)
            ->setLicense($license)
            ->setDDTCInformation($dDTCInformation);
    }
    /**
     * Get ExportInformation value
     * @return string|null
     */
    public function getExportInformation()
    {
        return $this->ExportInformation;
    }
    /**
     * Set ExportInformation value
     * @param string $exportInformation
     * @return \Ups_ship\UPSshipStruct\Ups_shipEEIInformationType
     */
    public function setExportInformation($exportInformation = null)
    {
        // validation for constraint: string
        if (!is_null($exportInformation) && !is_string($exportInformation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($exportInformation, true), gettype($exportInformation)), __LINE__);
        }
        $this->ExportInformation = $exportInformation;
        return $this;
    }
    /**
     * Get License value
     * @return \Ups_ship\UPSshipStruct\Ups_shipEEILicenseType|null
     */
    public function getLicense()
    {
        return $this->License;
    }
    /**
     * Set License value
     * @param \Ups_ship\UPSshipStruct\Ups_shipEEILicenseType $license
     * @return \Ups_ship\UPSshipStruct\Ups_shipEEIInformationType
     */
    public function setLicense(\Ups_ship\UPSshipStruct\Ups_shipEEILicenseType $license = null)
    {
        $this->License = $license;
        return $this;
    }
    /**
     * Get DDTCInformation value
     * @return \Ups_ship\UPSshipStruct\Ups_shipDDTCInformationType|null
     */
    public function getDDTCInformation()
    {
        return $this->DDTCInformation;
    }
    /**
     * Set DDTCInformation value
     * @param \Ups_ship\UPSshipStruct\Ups_shipDDTCInformationType $dDTCInformation
     * @return \Ups_ship\UPSshipStruct\Ups_shipEEIInformationType
     */
    public function setDDTCInformation(\Ups_ship\UPSshipStruct\Ups_shipDDTCInformationType $dDTCInformation = null)
    {
        $this->DDTCInformation = $dDTCInformation;
        return $this;
    }
}
