<?php

namespace Ups_ship\UPSshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FormType UPSshipStruct
 * @package Ups_ship
 * @subpackage Structs
 */
class Ups_shipFormType extends AbstractStructBase
{
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * The Description
     * @var string
     */
    public $Description;
    /**
     * The Image
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipFormImageType
     */
    public $Image;
    /**
     * The FormGroupId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FormGroupId;
    /**
     * The FormGroupIdName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FormGroupIdName;
    /**
     * Constructor method for FormType
     * @uses Ups_shipFormType::setCode()
     * @uses Ups_shipFormType::setDescription()
     * @uses Ups_shipFormType::setImage()
     * @uses Ups_shipFormType::setFormGroupId()
     * @uses Ups_shipFormType::setFormGroupIdName()
     * @param string $code
     * @param string $description
     * @param \Ups_ship\UPSshipStruct\Ups_shipFormImageType $image
     * @param string $formGroupId
     * @param string $formGroupIdName
     */
    public function __construct($code = null, $description = null, \Ups_ship\UPSshipStruct\Ups_shipFormImageType $image = null, $formGroupId = null, $formGroupIdName = null)
    {
        $this
            ->setCode($code)
            ->setDescription($description)
            ->setImage($image)
            ->setFormGroupId($formGroupId)
            ->setFormGroupIdName($formGroupIdName);
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \Ups_ship\UPSshipStruct\Ups_shipFormType
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \Ups_ship\UPSshipStruct\Ups_shipFormType
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Image value
     * @return \Ups_ship\UPSshipStruct\Ups_shipFormImageType|null
     */
    public function getImage()
    {
        return $this->Image;
    }
    /**
     * Set Image value
     * @param \Ups_ship\UPSshipStruct\Ups_shipFormImageType $image
     * @return \Ups_ship\UPSshipStruct\Ups_shipFormType
     */
    public function setImage(\Ups_ship\UPSshipStruct\Ups_shipFormImageType $image = null)
    {
        $this->Image = $image;
        return $this;
    }
    /**
     * Get FormGroupId value
     * @return string|null
     */
    public function getFormGroupId()
    {
        return $this->FormGroupId;
    }
    /**
     * Set FormGroupId value
     * @param string $formGroupId
     * @return \Ups_ship\UPSshipStruct\Ups_shipFormType
     */
    public function setFormGroupId($formGroupId = null)
    {
        // validation for constraint: string
        if (!is_null($formGroupId) && !is_string($formGroupId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($formGroupId, true), gettype($formGroupId)), __LINE__);
        }
        $this->FormGroupId = $formGroupId;
        return $this;
    }
    /**
     * Get FormGroupIdName value
     * @return string|null
     */
    public function getFormGroupIdName()
    {
        return $this->FormGroupIdName;
    }
    /**
     * Set FormGroupIdName value
     * @param string $formGroupIdName
     * @return \Ups_ship\UPSshipStruct\Ups_shipFormType
     */
    public function setFormGroupIdName($formGroupIdName = null)
    {
        // validation for constraint: string
        if (!is_null($formGroupIdName) && !is_string($formGroupIdName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($formGroupIdName, true), gettype($formGroupIdName)), __LINE__);
        }
        $this->FormGroupIdName = $formGroupIdName;
        return $this;
    }
}
