<?php

namespace Ups_ship\UPSshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FreightDensityRateType UPSshipStruct
 * @package Ups_ship
 * @subpackage Structs
 */
class Ups_shipFreightDensityRateType extends AbstractStructBase
{
    /**
     * The Density
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Density;
    /**
     * The TotalCubicFeet
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TotalCubicFeet;
    /**
     * Constructor method for FreightDensityRateType
     * @uses Ups_shipFreightDensityRateType::setDensity()
     * @uses Ups_shipFreightDensityRateType::setTotalCubicFeet()
     * @param string $density
     * @param string $totalCubicFeet
     */
    public function __construct($density = null, $totalCubicFeet = null)
    {
        $this
            ->setDensity($density)
            ->setTotalCubicFeet($totalCubicFeet);
    }
    /**
     * Get Density value
     * @return string|null
     */
    public function getDensity()
    {
        return $this->Density;
    }
    /**
     * Set Density value
     * @param string $density
     * @return \Ups_ship\UPSshipStruct\Ups_shipFreightDensityRateType
     */
    public function setDensity($density = null)
    {
        // validation for constraint: string
        if (!is_null($density) && !is_string($density)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($density, true), gettype($density)), __LINE__);
        }
        $this->Density = $density;
        return $this;
    }
    /**
     * Get TotalCubicFeet value
     * @return string|null
     */
    public function getTotalCubicFeet()
    {
        return $this->TotalCubicFeet;
    }
    /**
     * Set TotalCubicFeet value
     * @param string $totalCubicFeet
     * @return \Ups_ship\UPSshipStruct\Ups_shipFreightDensityRateType
     */
    public function setTotalCubicFeet($totalCubicFeet = null)
    {
        // validation for constraint: string
        if (!is_null($totalCubicFeet) && !is_string($totalCubicFeet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($totalCubicFeet, true), gettype($totalCubicFeet)), __LINE__);
        }
        $this->TotalCubicFeet = $totalCubicFeet;
        return $this;
    }
}
