<?php

namespace Ups_ship\UPSshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FreightShipmentInformationType UPSshipStruct
 * @package Ups_ship
 * @subpackage Structs
 */
class Ups_shipFreightShipmentInformationType extends AbstractStructBase
{
    /**
     * The FreightDensityInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipFreightDensityInfoType
     */
    public $FreightDensityInfo;
    /**
     * The DensityEligibleIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DensityEligibleIndicator;
    /**
     * Constructor method for FreightShipmentInformationType
     * @uses Ups_shipFreightShipmentInformationType::setFreightDensityInfo()
     * @uses Ups_shipFreightShipmentInformationType::setDensityEligibleIndicator()
     * @param \Ups_ship\UPSshipStruct\Ups_shipFreightDensityInfoType $freightDensityInfo
     * @param string $densityEligibleIndicator
     */
    public function __construct(\Ups_ship\UPSshipStruct\Ups_shipFreightDensityInfoType $freightDensityInfo = null, $densityEligibleIndicator = null)
    {
        $this
            ->setFreightDensityInfo($freightDensityInfo)
            ->setDensityEligibleIndicator($densityEligibleIndicator);
    }
    /**
     * Get FreightDensityInfo value
     * @return \Ups_ship\UPSshipStruct\Ups_shipFreightDensityInfoType|null
     */
    public function getFreightDensityInfo()
    {
        return $this->FreightDensityInfo;
    }
    /**
     * Set FreightDensityInfo value
     * @param \Ups_ship\UPSshipStruct\Ups_shipFreightDensityInfoType $freightDensityInfo
     * @return \Ups_ship\UPSshipStruct\Ups_shipFreightShipmentInformationType
     */
    public function setFreightDensityInfo(\Ups_ship\UPSshipStruct\Ups_shipFreightDensityInfoType $freightDensityInfo = null)
    {
        $this->FreightDensityInfo = $freightDensityInfo;
        return $this;
    }
    /**
     * Get DensityEligibleIndicator value
     * @return string|null
     */
    public function getDensityEligibleIndicator()
    {
        return $this->DensityEligibleIndicator;
    }
    /**
     * Set DensityEligibleIndicator value
     * @param string $densityEligibleIndicator
     * @return \Ups_ship\UPSshipStruct\Ups_shipFreightShipmentInformationType
     */
    public function setDensityEligibleIndicator($densityEligibleIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($densityEligibleIndicator) && !is_string($densityEligibleIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($densityEligibleIndicator, true), gettype($densityEligibleIndicator)), __LINE__);
        }
        $this->DensityEligibleIndicator = $densityEligibleIndicator;
        return $this;
    }
}
