<?php

namespace Ups_ship\UPSshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NegotiatedRateChargesType UPSshipStruct
 * @package Ups_ship
 * @subpackage Structs
 */
class Ups_shipNegotiatedRateChargesType extends AbstractStructBase
{
    /**
     * The ItemizedCharges
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipShipChargeType[]
     */
    public $ItemizedCharges;
    /**
     * The TaxCharges
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipTaxChargeType[]
     */
    public $TaxCharges;
    /**
     * The TotalCharge
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipShipChargeType
     */
    public $TotalCharge;
    /**
     * The TotalChargesWithTaxes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_ship\UPSshipStruct\Ups_shipShipChargeType
     */
    public $TotalChargesWithTaxes;
    /**
     * Constructor method for NegotiatedRateChargesType
     * @uses Ups_shipNegotiatedRateChargesType::setItemizedCharges()
     * @uses Ups_shipNegotiatedRateChargesType::setTaxCharges()
     * @uses Ups_shipNegotiatedRateChargesType::setTotalCharge()
     * @uses Ups_shipNegotiatedRateChargesType::setTotalChargesWithTaxes()
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType[] $itemizedCharges
     * @param \Ups_ship\UPSshipStruct\Ups_shipTaxChargeType[] $taxCharges
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $totalCharge
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $totalChargesWithTaxes
     */
    public function __construct(array $itemizedCharges = array(), array $taxCharges = array(), \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $totalCharge = null, \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $totalChargesWithTaxes = null)
    {
        $this
            ->setItemizedCharges($itemizedCharges)
            ->setTaxCharges($taxCharges)
            ->setTotalCharge($totalCharge)
            ->setTotalChargesWithTaxes($totalChargesWithTaxes);
    }
    /**
     * Get ItemizedCharges value
     * @return \Ups_ship\UPSshipStruct\Ups_shipShipChargeType[]|null
     */
    public function getItemizedCharges()
    {
        return $this->ItemizedCharges;
    }
    /**
     * This method is responsible for validating the values passed to the setItemizedCharges method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItemizedCharges method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItemizedChargesForArrayConstraintsFromSetItemizedCharges(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $negotiatedRateChargesTypeItemizedChargesItem) {
            // validation for constraint: itemType
            if (!$negotiatedRateChargesTypeItemizedChargesItem instanceof \Ups_ship\UPSshipStruct\Ups_shipShipChargeType) {
                $invalidValues[] = is_object($negotiatedRateChargesTypeItemizedChargesItem) ? get_class($negotiatedRateChargesTypeItemizedChargesItem) : sprintf('%s(%s)', gettype($negotiatedRateChargesTypeItemizedChargesItem), var_export($negotiatedRateChargesTypeItemizedChargesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ItemizedCharges property can only contain items of type \Ups_ship\UPSshipStruct\Ups_shipShipChargeType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ItemizedCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType[] $itemizedCharges
     * @return \Ups_ship\UPSshipStruct\Ups_shipNegotiatedRateChargesType
     */
    public function setItemizedCharges(array $itemizedCharges = array())
    {
        // validation for constraint: array
        if ('' !== ($itemizedChargesArrayErrorMessage = self::validateItemizedChargesForArrayConstraintsFromSetItemizedCharges($itemizedCharges))) {
            throw new \InvalidArgumentException($itemizedChargesArrayErrorMessage, __LINE__);
        }
        $this->ItemizedCharges = $itemizedCharges;
        return $this;
    }
    /**
     * Add item to ItemizedCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $item
     * @return \Ups_ship\UPSshipStruct\Ups_shipNegotiatedRateChargesType
     */
    public function addToItemizedCharges(\Ups_ship\UPSshipStruct\Ups_shipShipChargeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_ship\UPSshipStruct\Ups_shipShipChargeType) {
            throw new \InvalidArgumentException(sprintf('The ItemizedCharges property can only contain items of type \Ups_ship\UPSshipStruct\Ups_shipShipChargeType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ItemizedCharges[] = $item;
        return $this;
    }
    /**
     * Get TaxCharges value
     * @return \Ups_ship\UPSshipStruct\Ups_shipTaxChargeType[]|null
     */
    public function getTaxCharges()
    {
        return $this->TaxCharges;
    }
    /**
     * This method is responsible for validating the values passed to the setTaxCharges method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTaxCharges method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTaxChargesForArrayConstraintsFromSetTaxCharges(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $negotiatedRateChargesTypeTaxChargesItem) {
            // validation for constraint: itemType
            if (!$negotiatedRateChargesTypeTaxChargesItem instanceof \Ups_ship\UPSshipStruct\Ups_shipTaxChargeType) {
                $invalidValues[] = is_object($negotiatedRateChargesTypeTaxChargesItem) ? get_class($negotiatedRateChargesTypeTaxChargesItem) : sprintf('%s(%s)', gettype($negotiatedRateChargesTypeTaxChargesItem), var_export($negotiatedRateChargesTypeTaxChargesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TaxCharges property can only contain items of type \Ups_ship\UPSshipStruct\Ups_shipTaxChargeType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TaxCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_ship\UPSshipStruct\Ups_shipTaxChargeType[] $taxCharges
     * @return \Ups_ship\UPSshipStruct\Ups_shipNegotiatedRateChargesType
     */
    public function setTaxCharges(array $taxCharges = array())
    {
        // validation for constraint: array
        if ('' !== ($taxChargesArrayErrorMessage = self::validateTaxChargesForArrayConstraintsFromSetTaxCharges($taxCharges))) {
            throw new \InvalidArgumentException($taxChargesArrayErrorMessage, __LINE__);
        }
        $this->TaxCharges = $taxCharges;
        return $this;
    }
    /**
     * Add item to TaxCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_ship\UPSshipStruct\Ups_shipTaxChargeType $item
     * @return \Ups_ship\UPSshipStruct\Ups_shipNegotiatedRateChargesType
     */
    public function addToTaxCharges(\Ups_ship\UPSshipStruct\Ups_shipTaxChargeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_ship\UPSshipStruct\Ups_shipTaxChargeType) {
            throw new \InvalidArgumentException(sprintf('The TaxCharges property can only contain items of type \Ups_ship\UPSshipStruct\Ups_shipTaxChargeType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TaxCharges[] = $item;
        return $this;
    }
    /**
     * Get TotalCharge value
     * @return \Ups_ship\UPSshipStruct\Ups_shipShipChargeType|null
     */
    public function getTotalCharge()
    {
        return $this->TotalCharge;
    }
    /**
     * Set TotalCharge value
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $totalCharge
     * @return \Ups_ship\UPSshipStruct\Ups_shipNegotiatedRateChargesType
     */
    public function setTotalCharge(\Ups_ship\UPSshipStruct\Ups_shipShipChargeType $totalCharge = null)
    {
        $this->TotalCharge = $totalCharge;
        return $this;
    }
    /**
     * Get TotalChargesWithTaxes value
     * @return \Ups_ship\UPSshipStruct\Ups_shipShipChargeType|null
     */
    public function getTotalChargesWithTaxes()
    {
        return $this->TotalChargesWithTaxes;
    }
    /**
     * Set TotalChargesWithTaxes value
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $totalChargesWithTaxes
     * @return \Ups_ship\UPSshipStruct\Ups_shipNegotiatedRateChargesType
     */
    public function setTotalChargesWithTaxes(\Ups_ship\UPSshipStruct\Ups_shipShipChargeType $totalChargesWithTaxes = null)
    {
        $this->TotalChargesWithTaxes = $totalChargesWithTaxes;
        return $this;
    }
}
