<?php

namespace Ups_ship\UPSshipStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TransportationChargeType UPSshipStruct
 * @package Ups_ship
 * @subpackage Structs
 */
class Ups_shipTransportationChargeType extends AbstractStructBase
{
    /**
     * The GrossCharge
     * @var \Ups_ship\UPSshipStruct\Ups_shipShipChargeType
     */
    public $GrossCharge;
    /**
     * The DiscountAmount
     * @var \Ups_ship\UPSshipStruct\Ups_shipShipChargeType
     */
    public $DiscountAmount;
    /**
     * The DiscountPercentage
     * @var string
     */
    public $DiscountPercentage;
    /**
     * The NetCharge
     * @var \Ups_ship\UPSshipStruct\Ups_shipShipChargeType
     */
    public $NetCharge;
    /**
     * Constructor method for TransportationChargeType
     * @uses Ups_shipTransportationChargeType::setGrossCharge()
     * @uses Ups_shipTransportationChargeType::setDiscountAmount()
     * @uses Ups_shipTransportationChargeType::setDiscountPercentage()
     * @uses Ups_shipTransportationChargeType::setNetCharge()
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $grossCharge
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $discountAmount
     * @param string $discountPercentage
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $netCharge
     */
    public function __construct(\Ups_ship\UPSshipStruct\Ups_shipShipChargeType $grossCharge = null, \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $discountAmount = null, $discountPercentage = null, \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $netCharge = null)
    {
        $this
            ->setGrossCharge($grossCharge)
            ->setDiscountAmount($discountAmount)
            ->setDiscountPercentage($discountPercentage)
            ->setNetCharge($netCharge);
    }
    /**
     * Get GrossCharge value
     * @return \Ups_ship\UPSshipStruct\Ups_shipShipChargeType|null
     */
    public function getGrossCharge()
    {
        return $this->GrossCharge;
    }
    /**
     * Set GrossCharge value
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $grossCharge
     * @return \Ups_ship\UPSshipStruct\Ups_shipTransportationChargeType
     */
    public function setGrossCharge(\Ups_ship\UPSshipStruct\Ups_shipShipChargeType $grossCharge = null)
    {
        $this->GrossCharge = $grossCharge;
        return $this;
    }
    /**
     * Get DiscountAmount value
     * @return \Ups_ship\UPSshipStruct\Ups_shipShipChargeType|null
     */
    public function getDiscountAmount()
    {
        return $this->DiscountAmount;
    }
    /**
     * Set DiscountAmount value
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $discountAmount
     * @return \Ups_ship\UPSshipStruct\Ups_shipTransportationChargeType
     */
    public function setDiscountAmount(\Ups_ship\UPSshipStruct\Ups_shipShipChargeType $discountAmount = null)
    {
        $this->DiscountAmount = $discountAmount;
        return $this;
    }
    /**
     * Get DiscountPercentage value
     * @return string|null
     */
    public function getDiscountPercentage()
    {
        return $this->DiscountPercentage;
    }
    /**
     * Set DiscountPercentage value
     * @param string $discountPercentage
     * @return \Ups_ship\UPSshipStruct\Ups_shipTransportationChargeType
     */
    public function setDiscountPercentage($discountPercentage = null)
    {
        // validation for constraint: string
        if (!is_null($discountPercentage) && !is_string($discountPercentage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($discountPercentage, true), gettype($discountPercentage)), __LINE__);
        }
        $this->DiscountPercentage = $discountPercentage;
        return $this;
    }
    /**
     * Get NetCharge value
     * @return \Ups_ship\UPSshipStruct\Ups_shipShipChargeType|null
     */
    public function getNetCharge()
    {
        return $this->NetCharge;
    }
    /**
     * Set NetCharge value
     * @param \Ups_ship\UPSshipStruct\Ups_shipShipChargeType $netCharge
     * @return \Ups_ship\UPSshipStruct\Ups_shipTransportationChargeType
     */
    public function setNetCharge(\Ups_ship\UPSshipStruct\Ups_shipShipChargeType $netCharge = null)
    {
        $this->NetCharge = $netCharge;
        return $this;
    }
}
