<?php

namespace Ups_ship;

/**
 * Class which returns the class map definition
 * @package Ups_ship
 */
class Ups_shipClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'UPSSecurity' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUPSSecurity',
            'UsernameToken' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUsernameToken',
            'ServiceAccessToken' => '\\Ups_ship\\UPSshipStruct\\Ups_shipServiceAccessToken',
            'Errors' => '\\Ups_ship\\UPSshipStruct\\Ups_shipErrors',
            'ErrorDetailType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipErrorDetailType',
            'ElementLevelInformationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipElementLevelInformationType',
            'ElementIdentifierType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipElementIdentifierType',
            'CodeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCodeType',
            'AdditionalInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipAdditionalInfoType',
            'AdditionalCodeDescType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipAdditionalCodeDescType',
            'LocationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLocationType',
            'ClientInformationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipClientInformationType',
            'Property' => '\\Ups_ship\\UPSshipStruct\\Ups_shipProperty',
            'RequestType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipRequestType',
            'TransactionReferenceType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipTransactionReferenceType',
            'ResponseType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipResponseType',
            'CodeDescriptionType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCodeDescriptionType',
            'DetailType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipDetailType',
            'InternationalFormType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipInternationalFormType',
            'UPSPremiumCareFormType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUPSPremiumCareFormType',
            'LanguageForUPSPremiumCareType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLanguageForUPSPremiumCareType',
            'UserCreatedFormType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUserCreatedFormType',
            'CN22FormType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCN22FormType',
            'CN22ContentType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCN22ContentType',
            'ContactType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipContactType',
            'ForwardAgentType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipForwardAgentType',
            'AddressType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipAddressType',
            'UltimateConsigneeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUltimateConsigneeType',
            'IntermediateConsigneeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipIntermediateConsigneeType',
            'ProducerType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipProducerType',
            'ProductType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipProductType',
            'ExcludeFromFormType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipExcludeFromFormType',
            'UnitType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUnitType',
            'PackingListInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPackingListInfoType',
            'PackageAssociatedType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPackageAssociatedType',
            'UnitOfMeasurementType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUnitOfMeasurementType',
            'NetCostDateType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipNetCostDateType',
            'ProductWeightType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipProductWeightType',
            'ScheduleBType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipScheduleBType',
            'IFChargesType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipIFChargesType',
            'OtherChargesType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipOtherChargesType',
            'BlanketPeriodType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipBlanketPeriodType',
            'LicenseType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLicenseType',
            'SoldToType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipSoldToType',
            'PhoneType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPhoneType',
            'DDTCInformationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipDDTCInformationType',
            'EEILicenseType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipEEILicenseType',
            'EEIFilingOptionType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipEEIFilingOptionType',
            'UPSFiledType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUPSFiledType',
            'ShipperFiledType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipperFiledType',
            'EEIInformationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipEEIInformationType',
            'POAType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPOAType',
            'UltimateConsigneeTypeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUltimateConsigneeTypeType',
            'ShipmentRequest' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentRequest',
            'ShipConfirmRequest' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipConfirmRequest',
            'ShipAcceptRequest' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipAcceptRequest',
            'ShipmentResponse' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentResponse',
            'ShipConfirmResponse' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipConfirmResponse',
            'ShipAcceptResponse' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipAcceptResponse',
            'ShipmentType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentType',
            'ShipmentServiceOptions' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentServiceOptions',
            'PromotionalDiscountInformationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPromotionalDiscountInformationType',
            'ReturnServiceType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipReturnServiceType',
            'ShipperType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipperType',
            'CompanyInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCompanyInfoType',
            'ShipPhoneType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipPhoneType',
            'ShipAddressType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipAddressType',
            'ShipToType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipToType',
            'ShipToAddressType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipToAddressType',
            'ShipFromType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipFromType',
            'PrepaidType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPrepaidType',
            'BillShipperType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipBillShipperType',
            'CreditCardType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCreditCardType',
            'CreditCardAddressType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCreditCardAddressType',
            'BillThirdPartyChargeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipBillThirdPartyChargeType',
            'AccountAddressType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipAccountAddressType',
            'FreightCollectType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipFreightCollectType',
            'BillReceiverType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipBillReceiverType',
            'BillReceiverAddressType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipBillReceiverAddressType',
            'PaymentInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPaymentInfoType',
            'ShipmentChargeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentChargeType',
            'FRSPaymentInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipFRSPaymentInfoType',
            'PaymentType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPaymentType',
            'RateInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipRateInfoType',
            'ReferenceNumberType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipReferenceNumberType',
            'ServiceType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipServiceType',
            'CurrencyMonetaryType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCurrencyMonetaryType',
            'ShipmentServiceOptionsType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentServiceOptionsType',
            'RestrictedArticlesType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipRestrictedArticlesType',
            'PreAlertNotificationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPreAlertNotificationType',
            'PreAlertEMailMessageType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPreAlertEMailMessageType',
            'LocaleType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLocaleType',
            'PreAlertVoiceMessageType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPreAlertVoiceMessageType',
            'PreAlertTextMessageType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPreAlertTextMessageType',
            'ContactInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipContactInfoType',
            'CODType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCODType',
            'ShipmentServiceOptionsAccessPointCODType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentServiceOptionsAccessPointCODType',
            'NotificationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipNotificationType',
            'LabelDeliveryType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLabelDeliveryType',
            'EmailDetailsType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipEmailDetailsType',
            'PackageType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPackageType',
            'PackagingType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPackagingType',
            'DimensionsType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipDimensionsType',
            'ShipUnitOfMeasurementType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipUnitOfMeasurementType',
            'PackageWeightType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPackageWeightType',
            'PackageServiceOptionsType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPackageServiceOptionsType',
            'PackageDeclaredValueType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPackageDeclaredValueType',
            'DeclaredValueType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipDeclaredValueType',
            'DeliveryConfirmationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipDeliveryConfirmationType',
            'LabelMethodType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLabelMethodType',
            'PSOCODType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPSOCODType',
            'PackageServiceOptionsAccessPointCODType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPackageServiceOptionsAccessPointCODType',
            'PSONotificationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPSONotificationType',
            'LabelSpecificationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLabelSpecificationType',
            'InstructionCodeDescriptionType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipInstructionCodeDescriptionType',
            'LabelImageFormatType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLabelImageFormatType',
            'LabelStockSizeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLabelStockSizeType',
            'CommodityType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCommodityType',
            'NMFCType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipNMFCType',
            'ShipmentResultsType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentResultsType',
            'DisclaimerType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipDisclaimerType',
            'ShipmentChargesType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentChargesType',
            'EstimatedDutiesAndTaxesType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipEstimatedDutiesAndTaxesType',
            'BrokerageFeesType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipBrokerageFeesType',
            'NegotiatedRateChargesType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipNegotiatedRateChargesType',
            'ShipChargeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipChargeType',
            'TaxChargeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipTaxChargeType',
            'FRSShipmentDataType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipFRSShipmentDataType',
            'TransportationChargeType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipTransportationChargeType',
            'BillingWeightType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipBillingWeightType',
            'BillingUnitOfMeasurementType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipBillingUnitOfMeasurementType',
            'PackageResultsType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipPackageResultsType',
            'CommodityDutyChargesType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipCommodityDutyChargesType',
            'AccessorialType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipAccessorialType',
            'LabelType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipLabelType',
            'ReceiptType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipReceiptType',
            'ImageType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipImageType',
            'FormType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipFormType',
            'FormImageType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipFormImageType',
            'ImageFormatType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipImageFormatType',
            'SCReportType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipSCReportType',
            'HighValueReportType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipHighValueReportType',
            'HazMatPackageInformationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipHazMatPackageInformationType',
            'HazMatType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipHazMatType',
            'DryIceType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipDryIceType',
            'DryIceWeightType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipDryIceWeightType',
            'ReceiptSpecificationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipReceiptSpecificationType',
            'ReceiptImageFormatType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipReceiptImageFormatType',
            'TaxIDCodeDescType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipTaxIDCodeDescType',
            'IndicationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipIndicationType',
            'AlternateDeliveryAddressType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipAlternateDeliveryAddressType',
            'ShipmentServiceOptionsNotificationVoiceMessageType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentServiceOptionsNotificationVoiceMessageType',
            'ShipmentServiceOptionsNotificationTextMessageType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipShipmentServiceOptionsNotificationTextMessageType',
            'ADLAddressType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipADLAddressType',
            'FreightShipmentInformationType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipFreightShipmentInformationType',
            'HandlingUnitsType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipHandlingUnitsType',
            'HandlingUnitsResponseType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipHandlingUnitsResponseType',
            'HandlingUnitsDimensionsType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipHandlingUnitsDimensionsType',
            'FreightDensityRateType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipFreightDensityRateType',
            'FreightDensityInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipFreightDensityInfoType',
            'AdjustedHeightType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipAdjustedHeightType',
            'NegotiatedChargesType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipNegotiatedChargesType',
            'DGSignatoryInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipDGSignatoryInfoType',
            'UPSPremierType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipUPSPremierType',
            'HandlingInstructionsType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipHandlingInstructionsType',
            'SimpleRateType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipSimpleRateType',
            'VendorInfoType' => '\\Ups_ship\\UPSshipStruct\\Ups_shipVendorInfoType',
        );
    }
}
